<?php

/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Controllers\Administrator;

use App\Exceptions\DefaultException;
use App\Http\Base\BaseController;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use App\Http\Services\PenggunaanmakananService;
use App\Http\Services\ItempenggunaanbarangService;
use App\Http\Services\StokkapalService;
use App\Http\Services\ItemService;
use App\Http\Models\ItemonhandModel;
use App\Http\Services\UsersService;
use App\Http\Services\KapalService;
use App\Http\Services\VoyagesService;
use App\Http\Validators\PindahsubinvValidator;
use PDF;

class ReportsController extends BaseController
{
    protected $penggunaanmakanan;
    protected $itempenggunaanbarang;
    private $stokkapal;
    protected $voyage;
    protected $kapal;
    protected $item;

    private $users;
    /**
     * Pindahsubinv constructor.
     */
    public function __construct()
    {
        parent::__construct();
        $this->penggunaanmakanan = new PenggunaanmakananService();
        $this->itempenggunaanbarang = new ItempenggunaanbarangService();
        $this->stokkapal = new StokkapalService();
        $this->voyage = new VoyagesService();
        $this->kapal = new KapalService();
        $this->item = new ItemService();
        $this->users = new UsersService();
    }

    public function rekapitulasiPaging(Request $request)
    {
        $this->data["voyages"] = $this->voyage->getVoyages($request);
        $this->data["kapals"] = $this->kapal->getList($request);
        $this->data["mealTypes"] = $this->item->getMealType($request);
        return view("modules.reports.biayamakanan_index", $this->data);
    }

    public function rekapitulasiReport(Request $request)
    {
        set_time_limit(0);
        ini_set('max_execution_time', 0);
        ini_set('memory_limit', '-1');

        PDF::SetTitle('Rekapitulasi Biaya Layanan Makan Nahkoda/ABK');
        PDF::AddPage();

        $data['totalPageCount'] = PDF::getAliasNbPages();

        $input = $request->all();
        $auth = json_decode($request->session()->get('auth'));
        $data["headerNo"]  = $input["headerNo"];
        $data["headerRev"]  = $input["headerRev"];

        $data["dateStart"]    = $dateStart  = $input["dateStart"];
        $data["dateEnd"]    = $dateEnd    = $input["dateEnd"];
        $kapalId    = $input["kapalId"];
        $voyageKode = $input["voyageKode"];
        $mealType   = $input["meal_type"];
        $data["items"] = $this->penggunaanmakanan->getRekapitulasi($kapalId, $voyageKode, $dateStart, $dateEnd, $mealType);

        $data["voyage"] = $this->voyage->show($voyageKode, "voyageKode", "=");
        $data["kapal"] = $this->kapal->show($kapalId);

        $data["requester"] = $this->users->show($input["requesterId"]);
        $data["approver"] = $this->users->getNahkodaProfile($kapalId, $auth->sysParams->JABATANNAHKODA);
        if (!$data["approver"]) {
            $data["approver"] = $data["requester"];
        }

        $view = \View::make("modules.reports.biayamakanan_pdf", $data);
        $htmlContent = $view->render();
        PDF::writeHTML($htmlContent, true, false, true, false . "");
        PDF::Output('gandroom.pdf');
    }


    public function bahanMakananReport(Request $request)
    {
        $auth = json_decode($request->session()->get('auth'));

        PDF::SetTitle('Pemakaian Bahan Makanan');
        PDF::AddPage();

        $data['totalPageCount'] = PDF::getAliasNbPages();;
        $input = $request->all();
        $data["dateStart"]  = $dateStart  = $input["dateStart"]; // $input["monthYear"] . "-01";
        $data["dateEnd"]    = $dateEnd  = $input["dateEnd"]; // date("Y-m-t", strtotime($dateStart));
        $data["headerNo"]   = $input["headerNo"];
        $data["headerRev"]  = $input["headerRev"];
        $data["jlhOrang"]   = $input["jlhOrang"];
        $kapalId  = $input["kapalId"];
        $voyageKode  = $input["voyageKode"];

        $data["voyage"] = $this->voyage->show($voyageKode, "voyageKode", "=");
        $data["kapal"] = $this->kapal->show($kapalId);

        $data["requester"] = $this->users->show($input["requesterId"]);
        $data["approver"] = $this->users->getNahkodaProfile($kapalId, $auth->sysParams->JABATANNAHKODA);
        if (!$data["approver"]) {
            $data["approver"] = $data["requester"];
        }

        $data["items"] = $this->stokkapal->reportBahanMakanan($request, $dateStart, $dateEnd);

        $view = \View::make("modules.reports.bahanmakanan_pdf", $data);
        $htmlContent = $view->render();
        PDF::writeHTML($htmlContent, true, false, true, false . "");
        PDF::Output('penggunaanbarang-barang.pdf');
    }

    public function bahanMakananPaging(Request $request)
    {
        $this->data["kapals"] = $this->kapal->getList($request);
        return view("modules.reports.bahanmakanan_index", $this->data);
    }


    public function stockcardReport(Request $request)
    {

        $data["namaTransaksi"] = [
            "penerimaanmakanan" => "Penerimaan Makanan",
            "penerimaanbarang" => "Penerimaan Barang",
            "pindahbarangio" => "Transfer IO",
            "penggunaanmakanan" => "Penggunaan Makanan",
            "pindahbarangsubinv" => "Transfer Subinventory",
            "penerimaanbarangio" => "Penerimaan IO",
            "penggunaanbarang" => "Penggunaan Barang",
            "RCV_RETURN" => "Adjusment Penerimaan",
            "RCV_CORRECTION" => "Adjusment Penerimaan",
            "MISC_ISSUE_ADJ" => "Adjusment Penggunaan",
            "MISC_RCV_ADJ" => "Adjusment Penggunaan"
        ];

        $auth = json_decode($request->session()->get('auth'));

        PDF::SetTitle('Catatan Harian Persediaan Bahan Baku Makanan');
        PDF::AddPage();
        PDF::setPageOrientation("L");
        $input = $request->all();
        $dateReport = $input["monthYear"];
        $dateStart  =  date("Y-m-01", strtotime($input["monthYear"]));
        $dateEnd  = date("Y-m-t", strtotime($dateStart));
        $kapalId  = $input["kapalId"];
        $data["kapal"] = $this->kapal->show($kapalId);

        $data["periode"] = date("d M Y", strtotime($dateStart)) . " s/d " . date("d M Y", strtotime($dateEnd));

        $data["items"] = $this->stokkapal->reportStockCard($request, $dateStart, $dateEnd);

        $data["requester"] = $this->users->show($input["requesterId"]);
        $data["approver"] = $this->users->getNahkodaProfile($kapalId, $auth->sysParams->JABATANNAHKODA);
        if (!$data["approver"]) {
            $data["approver"] = $data["requester"];
        }

        $data['totalPageCount'] = PDF::getAliasNbPages();
        $view = \View::make("modules.reports.stockcard_pdf", $data);
        $htmlContent = $view->render();
        PDF::writeHTML($htmlContent, true, false, true, false . "");
        PDF::Output('stockcard-makanan.pdf');
    }

    public function stockcardPaging(Request $request)
    {
        $this->data["kapals"] = $this->kapal->getList($request);
        return view("modules.reports.stockcard_index", $this->data);
    }

    public function bbmminyakPaging(Request $request)
    {
        return view("modules.reports.bbmminyak_index", $this->data);
    }

    public function bbmminyakReport(Request $request)
    {
        PDF::SetTitle('PERMINTAAN  BBM &amp; MINYAK PELUMAS');
        PDF::AddPage();

        $data['totalPageCount'] = PDF::getAliasNbPages();

        $input = $request->all();
        $dateReport = $input["monthYear"];
        $dateStart  =  date("Y-m-01", strtotime($input["monthYear"]));
        $dateEnd  = date("Y-m-t", strtotime($dateStart));
        $kapalId  = $input["kapalId"];

        $data["requester"] = $this->users->show($input["requesterId"]);
        $data["approver"] = $data["requester"];

        $view = \View::make("modules.reports.bbmminyak_pdf", $data);
        $htmlContent = $view->render();
        PDF::writeHTML($htmlContent, true, false, true, false . "");
        PDF::Output('bunker.pdf');
    }

    public function bunkerPaging(Request $request)
    {
        return view("modules.reports.bunker_index", $this->data);
    }

    public function bunkerReport(Request $request)
    {
        PDF::SetTitle('BERITA ACARA BUNKER');
        PDF::AddPage();

        $data['totalPageCount'] = PDF::getAliasNbPages();

        $input = $request->all();
        $dateReport = $input["monthYear"];
        $dateStart  =  date("Y-m-01", strtotime($input["monthYear"]));
        $dateEnd  = date("Y-m-t", strtotime($dateStart));
        $kapalId  = $input["kapalId"];

        $data["requester"] = $this->users->show($input["requesterId"]);
        $data["approver"] = $data["requester"];

        $view = \View::make("modules.reports.bunker_pdf", $data);
        $htmlContent = $view->render();
        PDF::writeHTML($htmlContent, true, false, true, false . "");
        PDF::Output('bunker.pdf');
    }

    public function sparepartReport(Request $request)
    {
        $auth = json_decode($request->session()->get('auth'));

        PDF::SetTitle('Laporan Bulanan Penerimaan dan Pemakainan Suku Cadang, Perkakas, Dan Lain-lain yang Diterima Dari Divisi Pengadaan Ataupun Dari Perwakilan Lainnya.');
        PDF::AddPage();
        // PDF::setPageOrientation("L");

        $data['totalPageCount'] = PDF::getAliasNbPages();
        $input = $request->all();
        $dateReport = $input["monthYear"];
        $dateStart  =  date("Y-m-01", strtotime($input["monthYear"]));
        $dateEnd  = date("Y-m-t", strtotime($dateStart));

        $data["periode"] = date("F / Y", strtotime($dateEnd));

        $data["items"] = $this->stokkapal->reportSparePart($request, $dateStart, $dateEnd);

        $data["requester"] = $this->users->show($input["requesterId"]);
        $data["approver"] = $this->users->getNahkodaProfile($auth->kapalId, $auth->sysParams->JABATANNAHKODA);
        if (!$data["approver"]) {
            $data["approver"] = $data["requester"];
        }

        $view = \View::make("modules.reports.sparepart_pdf", $data);
        $htmlContent = $view->render();
        PDF::writeHTML($htmlContent, true, false, true, false . "");
        PDF::Output('sparepart-report.pdf');
    }

    public function sparepartPaging(Request $request)
    {
        $auth = json_decode($request->session()->get('auth'));
        if (isset($auth->sysParams->SPAREPART)) {
            $this->data["kapals"] = $this->kapal->getListNotIn([$auth->kapalId]);
            return view("modules.reports.sparepart_index", $this->data);
        } else {
            return redirect()->to("administrator/")->with("errMessage", "System Paramter: SPAREPART belum di set. Please check this with your Administrator/Nahkoda.");
        }
    }
}
